## ros-melodic-open-karto 1.2.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.2)
project(open_karto)

find_package(catkin REQUIRED)

find_package(Boost REQUIRED COMPONENTS thread)

catkin_package(
  DEPENDS Boost
  INCLUDE_DIRS
    include
  LIBRARIES
    karto
)

if(BUILD_SHARED_LIBS)
  add_definitions(-DKARTO_DYNAMIC)
endif()

include_directories(include ${catkin_INCLUDE_DIRS} ${Boost_INCLUDE_DIRS})
add_library(karto SHARED src/Karto.cpp src/Mapper.cpp)
target_link_libraries(karto ${Boost_LIBRARIES})

install(DIRECTORY include/ DESTINATION include)
install(TARGETS karto
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_GLOBAL_BIN_DESTINATION}
)

=== samples/CMakeLists.txt ===
#
# Copyright 2010 SRI International
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

ADD_DEFINITIONS(-DUSE_SPA)

if(WIN32)
  ADD_DEFINITIONS(-DEIGEN_DONT_ALIGN)
endif()

if(WIN32)
  # turn off various warnings
  foreach(warning 4251)
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd${warning}")
  endforeach(warning)
endif()

include_directories(../source)

############################################################################
# tutorial 1
add_executable(
  Karto_Tutorial1 
  tutorial1.cpp
)

target_link_libraries(Karto_Tutorial1 OpenKarto)

if (UNIX)
  target_link_libraries(Karto_Tutorial1 "pthread")
endif()

############################################################################
# tutorial 2

include_directories(${CSPARSE_DIR}/CSparse/Include)
include_directories(${SBA_DIR}/sba/include)
include_directories(${EIGEN_DIR}/eigen)

add_executable(
  Karto_Tutorial2
  tutorial2.cpp
  SpaSolver.h
  SpaSolver.cpp
)

target_link_libraries(Karto_Tutorial2 OpenKarto)
target_link_libraries(Karto_Tutorial2 spa2d)
target_link_libraries(Karto_Tutorial2 csparse)

if(PNG_FOUND)
  target_link_libraries(Karto_Tutorial2 ${ZLIB_LIBRARIES})
  target_link_libraries(Karto_Tutorial2 ${PNG_LIBRARIES})
endif()

if (UNIX)
  target_link_libraries(Karto_Tutorial2 "pthread")
endif()

=== debian/changelog ===
ros-melodic-open-karto (1.2.3-1bionic) bionic; urgency=high

  * update destructor to not use c11 feature (#26 <https://github.com/ros-perception/open_karto/issues/26>)
  * fix parameter passing bug of first link to other robots (#23 <https://github.com/ros-perception/open_karto/issues/23>)
  * Fix -Wdelete-non-virtual-dtor and -Wreorder warnings (#24 <https://github.com/ros-perception/open_karto/issues/24>)
  * Contributors: Michael Ferguson, Survy Vaish, Zezhou.Sun

 -- Michael Ferguson <mfergs7@gmail.com>  Tue, 10 Nov 2020 05:00:00 -0000

ros-melodic-open-karto (1.2.2-1bionic) bionic; urgency=high

  * Move the C++ classes and definitions of inline functions from the Mapper.cpp file to the Mapper.h file (#22 <https://github.com/ros-perception/open_karto/issues/22>)
  * add Hokuyo configuration in SetAngularResolution function (#20 <https://github.com/ros-perception/open_karto/issues/20>)
    Karto has five kinds of lidar parameter configurations (LMS100, LMS200, LMS291, UTM_30LX, URG_04LX), but there are only the first three configurations in the SetAngularResolution function, so I added the parameter configuration of UTM_30LX and URG_04LX.
  * Contributors: Jian Wen, Zezhou.Sun

 -- Michael Ferguson <mfergs7@gmail.com>  Fri, 07 Aug 2020 04:00:00 -0000

ros-melodic-open-karto (1.2.1-1bionic) bionic; urgency=high

  * bump version to silence CMP0048
  * Merge pull request #19 <https://github.com/ros-perception/open_karto/issues/19> from moriarty/patch-1
    Melodic: build status badges Indigo is EOL.
  * Melodic: build status badges Indigo is EOL.
  * Merge pull request #18 <https://github.com/ros-perception/open_karto/issues/18> from ms-iot/windows_port
    [Windows][melodic] Fix Windows build break
  * Changing maintainer email
  * Fix windows build.
  * Contributors: Alex Moriarty, Luc Bettaieb, Michael Ferguson, Sean Yen

 -- Michael Ferguson <mfergs7@gmail.com>  Fri, 24 Apr 2020 04:00:00 -0000

ros-melodic-open-karto (1.2.0-1bionic) bionic; urgency=high

  * Adds maintainer and branches for melodic
  * Merge pull request #14 <https://github.com/ros-perception/open_karto/issues/14> from ros-perception/maintainer-add
    Adding myself as a maintainer for open_karto
  * Adding myself as a maintainer for open_karto
  * Merge pull request #11 <https://github.com/ros-perception/open_karto/issues/11> from Maidbot/minimum_time_interval
    Process scan if enough time has elapsed since the previous one
  * Merge pull request #10 <https://github.com/ros-perception/open_karto/issues/10> from mikepurvis/fix-cpp11
    Use std::isnan/isinf, for C++11 compatibility.
  * [Mapper] Take time into account in HasMoveEnough
    The function HasMovedEnough now also returns true if more than MinimumTimeInterval time has elapsed since the previously processed laser scan
  * [Mapper] Add new parameter, MinimumTimeInterval
  * Use std::isnan/isinf, for C++11 compatibility.
  * Merge pull request #8 <https://github.com/ros-perception/open_karto/issues/8> from mig-em/feature/invalidScans1.1.4
    Add invalid scan detection for scanmatcher
  * Merge pull request #9 <https://github.com/ros-perception/open_karto/issues/9> from Maidbot/ignore_min_readings
    Ignore readings less than the sensor's minimum range
  * [Karto] Also ignore readings less than the minimum range
  * Add invalid scan detection for scanmatcher
  * Contributors: Luc Bettaieb, Michael Ferguson, Mike Purvis, Russell Toris, Spyros Maniatopoulos, mig-em

 -- Michael Ferguson <mfergs7@gmail.com>  Wed, 11 Jul 2018 04:00:00 -0000

ros-melodic-open-karto (1.1.4-1bionic) bionic; urgency=high

  * update build status badges
  * Adds LocalizedRangeScanWithPoints range scan
  * Contributors: Michael Ferguson, Russell Toris

 -- Michael Ferguson <mfergs7@gmail.com>  Wed, 02 Mar 2016 05:00:00 -0000

ros-melodic-open-karto (1.1.3-1bionic) bionic; urgency=high

  * Link against, and export depend on, boost
  * Contributors: Hai Nguyen, Michael Ferguson

 -- Michael Ferguson <mfergs7@gmail.com>  Tue, 16 Feb 2016 05:00:00 -0000

ros-melodic-open-karto (1.1.2-1bionic) bionic; urgency=high

  * Added getters and setters for parameters inside Mapper so they can be changed via the ROS param server.
  * Contributors: Luc Bettaieb, Michael Ferguson

 -- Michael Ferguson <mfergs7@gmail.com>  Mon, 13 Jul 2015 04:00:00 -0000

ros-melodic-open-karto (1.1.1-1bionic) bionic; urgency=high

  * Makes FindValidPoints robust to the first point in the scan being a NaN
  * Bump minimum cmake version requirement
  * Fix cppcheck warnings
  * Fix newlines (dos2unix) & superfluous whitespace
  * Protect functions that throw away const-ness (check dirty flag) with mutex
  * Don't modify scan during loop closure check - work on a copy of it
  * removed useless return to avoid cppcheck error
  * Add Mapper::SetUseScanMatching
  * Remove html entities from log output
  * Fix NANs cause raytracing to take forever
  * Contributors: Daniel Pinyol, Michael Ferguson, Paul Mathieu, Siegfried-A. Gevatter Pujals, liz-murphy

 -- Michael Ferguson <mfergs7@gmail.com>  Thu, 07 May 2015 04:00:00 -0000

ros-melodic-open-karto (1.1.0-1bionic) bionic; urgency=high

  * Release as a pure catkin ROS package

 -- Michael Ferguson <mfergs7@gmail.com>  Sun, 15 Jun 2014 04:00:00 -0000

=== debian/control ===
Source: ros-melodic-open-karto
Section: misc
Priority: optional
Maintainer: Michael Ferguson <mfergs7@gmail.com>
Build-Depends: debhelper (>= 9.0.0), libboost-all-dev, ros-melodic-catkin
Homepage: 
Standards-Version: 3.9.2

Package: ros-melodic-open-karto
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-all-dev
Description: Catkinized ROS packaging of the OpenKarto library

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/melodic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/melodic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/melodic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-melodic-open-karto//opt/ros/melodic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_install
